Blame


1 581fa623 2022-12-30 thomas #!/bin/sh
2 581fa623 2022-12-30 thomas #
3 581fa623 2022-12-30 thomas # Copyright (c) 2022 Mikhail Pchelin <misha@freebsd.org>
4 581fa623 2022-12-30 thomas #
5 581fa623 2022-12-30 thomas # Permission to use, copy, modify, and distribute this software for any
6 581fa623 2022-12-30 thomas # purpose with or without fee is hereby granted, provided that the above
7 581fa623 2022-12-30 thomas # copyright notice and this permission notice appear in all copies.
8 581fa623 2022-12-30 thomas #
9 581fa623 2022-12-30 thomas # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 581fa623 2022-12-30 thomas # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 581fa623 2022-12-30 thomas # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 581fa623 2022-12-30 thomas # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 581fa623 2022-12-30 thomas # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 581fa623 2022-12-30 thomas # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 581fa623 2022-12-30 thomas # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 581fa623 2022-12-30 thomas
17 581fa623 2022-12-30 thomas . ../cmdline/common.sh
18 581fa623 2022-12-30 thomas . ./common.sh
19 581fa623 2022-12-30 thomas
20 45b9d1e9 2022-12-30 thomas dummy_commit="aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
21 45b9d1e9 2022-12-30 thomas
22 581fa623 2022-12-30 thomas # Non-existent commit
23 581fa623 2022-12-30 thomas test_request_bad_commit() {
24 581fa623 2022-12-30 thomas local testroot=`test_init request_bad_commit`
25 581fa623 2022-12-30 thomas
26 45b9d1e9 2022-12-30 thomas echo "0054want $dummy_commit multi_ack side-band-64k ofs-delta" \
27 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/test-repo' \
28 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
29 581fa623 2022-12-30 thomas
30 45b9d1e9 2022-12-30 thomas echo -n "0041ERR object $dummy_commit not found" \
31 45b9d1e9 2022-12-30 thomas > $testroot/stdout.expected
32 581fa623 2022-12-30 thomas
33 45b9d1e9 2022-12-30 thomas echo "gotsh: object $dummy_commit not found" \
34 45b9d1e9 2022-12-30 thomas > $testroot/stderr.expected
35 581fa623 2022-12-30 thomas
36 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stdout.expected $testroot/stdout 0 112
37 581fa623 2022-12-30 thomas ret=$?
38 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
39 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
40 581fa623 2022-12-30 thomas test_done "$testroot" "1"
41 581fa623 2022-12-30 thomas return 1
42 581fa623 2022-12-30 thomas fi
43 581fa623 2022-12-30 thomas
44 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
45 581fa623 2022-12-30 thomas ret=$?
46 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
47 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
48 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
49 581fa623 2022-12-30 thomas test_done "$testroot" "1"
50 581fa623 2022-12-30 thomas return 1
51 581fa623 2022-12-30 thomas fi
52 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
53 581fa623 2022-12-30 thomas }
54 581fa623 2022-12-30 thomas
55 581fa623 2022-12-30 thomas # Zero pkt-len (as flush packet with payload)
56 581fa623 2022-12-30 thomas test_request_bad_length_zero() {
57 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_length_zero`
58 581fa623 2022-12-30 thomas
59 45b9d1e9 2022-12-30 thomas echo "0000want $dummy_commit multi_ack side-band-64k ofs-delta" \
60 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/test-repo' \
61 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
62 581fa623 2022-12-30 thomas
63 581fa623 2022-12-30 thomas echo -n "00000028ERR unexpected flush packet received" \
64 581fa623 2022-12-30 thomas > $testroot/stdout.expected
65 581fa623 2022-12-30 thomas
66 581fa623 2022-12-30 thomas echo "gotsh: unexpected flush packet received" \
67 581fa623 2022-12-30 thomas > $testroot/stderr.expected
68 581fa623 2022-12-30 thomas
69 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stdout.expected $testroot/stdout 0 108
70 581fa623 2022-12-30 thomas ret=$?
71 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
72 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
73 581fa623 2022-12-30 thomas test_done "$testroot" "1"
74 581fa623 2022-12-30 thomas return 1
75 581fa623 2022-12-30 thomas fi
76 581fa623 2022-12-30 thomas
77 581fa623 2022-12-30 thomas cmp -s $testroot/stderr $testroot/stderr.expected
78 581fa623 2022-12-30 thomas ret=$?
79 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
80 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
81 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
82 581fa623 2022-12-30 thomas test_done "$testroot" "1"
83 581fa623 2022-12-30 thomas return 1
84 581fa623 2022-12-30 thomas fi
85 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
86 581fa623 2022-12-30 thomas }
87 581fa623 2022-12-30 thomas
88 581fa623 2022-12-30 thomas # 0004 (empty)
89 581fa623 2022-12-30 thomas test_request_bad_length_empty() {
90 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_length_empty`
91 581fa623 2022-12-30 thomas
92 45b9d1e9 2022-12-30 thomas echo "0004want $dummy_commit multi_ack side-band-64k ofs-delta" \
93 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/test-repo' \
94 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
95 581fa623 2022-12-30 thomas
96 113392cf 2023-01-23 thomas echo -n '006c0000000000000000000000000000000000000000 ' \
97 581fa623 2022-12-30 thomas > $testroot/stdout.expected
98 113392cf 2023-01-23 thomas printf "capabilities^{}\0" >> $testroot/stdout.expected
99 113392cf 2023-01-23 thomas echo -n " agent=got/${GOT_VERSION_STR} ofs-delta side-band-64k" \
100 113392cf 2023-01-23 thomas >> $testroot/stdout.expected
101 113392cf 2023-01-23 thomas echo -n '00000018ERR packet too short' >> $testroot/stdout.expected
102 581fa623 2022-12-30 thomas
103 113392cf 2023-01-23 thomas echo "gotsh: packet too short" > $testroot/stderr.expected
104 581fa623 2022-12-30 thomas
105 113392cf 2023-01-23 thomas cmp -s $testroot/stdout.expected $testroot/stdout
106 581fa623 2022-12-30 thomas ret=$?
107 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
108 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
109 581fa623 2022-12-30 thomas test_done "$testroot" "1"
110 581fa623 2022-12-30 thomas return 1
111 581fa623 2022-12-30 thomas fi
112 581fa623 2022-12-30 thomas
113 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
114 581fa623 2022-12-30 thomas ret=$?
115 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
116 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
117 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
118 581fa623 2022-12-30 thomas test_done "$testroot" "1"
119 581fa623 2022-12-30 thomas return 1
120 581fa623 2022-12-30 thomas fi
121 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
122 581fa623 2022-12-30 thomas }
123 581fa623 2022-12-30 thomas
124 581fa623 2022-12-30 thomas # Pkt-len too small
125 581fa623 2022-12-30 thomas test_request_bad_length_small() {
126 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_length_small`
127 581fa623 2022-12-30 thomas
128 45b9d1e9 2022-12-30 thomas echo "0002want $dummy_commit multi_ack side-band-64k ofs-delta" \
129 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/test-repo' \
130 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
131 581fa623 2022-12-30 thomas
132 113392cf 2023-01-23 thomas echo -n '006c0000000000000000000000000000000000000000 ' \
133 581fa623 2022-12-30 thomas > $testroot/stdout.expected
134 113392cf 2023-01-23 thomas printf "capabilities^{}\0" >> $testroot/stdout.expected
135 113392cf 2023-01-23 thomas echo -n " agent=got/${GOT_VERSION_STR} ofs-delta side-band-64k" \
136 113392cf 2023-01-23 thomas >> $testroot/stdout.expected
137 113392cf 2023-01-23 thomas echo -n '00000018ERR packet too short' >> $testroot/stdout.expected
138 581fa623 2022-12-30 thomas
139 113392cf 2023-01-23 thomas echo "gotsh: packet too short" > $testroot/stderr.expected
140 581fa623 2022-12-30 thomas
141 113392cf 2023-01-23 thomas cmp -s $testroot/stdout.expected $testroot/stdout
142 581fa623 2022-12-30 thomas ret=$?
143 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
144 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
145 581fa623 2022-12-30 thomas test_done "$testroot" "1"
146 581fa623 2022-12-30 thomas return 1
147 581fa623 2022-12-30 thomas fi
148 581fa623 2022-12-30 thomas
149 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
150 581fa623 2022-12-30 thomas ret=$?
151 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
152 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
153 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
154 581fa623 2022-12-30 thomas test_done "$testroot" "1"
155 581fa623 2022-12-30 thomas return 1
156 581fa623 2022-12-30 thomas fi
157 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
158 581fa623 2022-12-30 thomas }
159 45b9d1e9 2022-12-30 thomas
160 581fa623 2022-12-30 thomas # Pkt-len too large
161 581fa623 2022-12-30 thomas test_request_bad_length_large() {
162 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_length_large`
163 581fa623 2022-12-30 thomas
164 45b9d1e9 2022-12-30 thomas echo "ffffwant $dummy_commit multi_ack side-band-64k ofs-delta" \
165 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/test-repo' \
166 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
167 581fa623 2022-12-30 thomas
168 113392cf 2023-01-23 thomas echo -n '006c0000000000000000000000000000000000000000 ' \
169 581fa623 2022-12-30 thomas > $testroot/stdout.expected
170 113392cf 2023-01-23 thomas printf "capabilities^{}\0" >> $testroot/stdout.expected
171 113392cf 2023-01-23 thomas echo -n " agent=got/${GOT_VERSION_STR} ofs-delta side-band-64k" \
172 113392cf 2023-01-23 thomas >> $testroot/stdout.expected
173 113392cf 2023-01-23 thomas echo -n '0000001eERR unexpected end of file' \
174 113392cf 2023-01-23 thomas >> $testroot/stdout.expected
175 581fa623 2022-12-30 thomas
176 113392cf 2023-01-23 thomas echo "gotsh: unexpected end of file" > $testroot/stderr.expected
177 581fa623 2022-12-30 thomas
178 113392cf 2023-01-23 thomas cmp -s $testroot/stdout.expected $testroot/stdout
179 581fa623 2022-12-30 thomas ret=$?
180 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
181 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
182 581fa623 2022-12-30 thomas test_done "$testroot" "1"
183 581fa623 2022-12-30 thomas return 1
184 581fa623 2022-12-30 thomas fi
185 581fa623 2022-12-30 thomas
186 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
187 581fa623 2022-12-30 thomas ret=$?
188 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
189 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
190 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
191 581fa623 2022-12-30 thomas test_done "$testroot" "1"
192 581fa623 2022-12-30 thomas return 1
193 581fa623 2022-12-30 thomas fi
194 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
195 581fa623 2022-12-30 thomas }
196 581fa623 2022-12-30 thomas
197 581fa623 2022-12-30 thomas # Unknown feature
198 581fa623 2022-12-30 thomas test_request_bad_capabilities() {
199 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_capabilities`
200 581fa623 2022-12-30 thomas
201 45b9d1e9 2022-12-30 thomas echo "0054want $dummy_commit aaaaaaaaa bbbbbbbbbbbbb ccccccccc" \
202 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/test-repo' \
203 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
204 581fa623 2022-12-30 thomas
205 581fa623 2022-12-30 thomas echo -n "00000025ERR unexpected want-line received" \
206 581fa623 2022-12-30 thomas > $testroot/stdout.expected
207 581fa623 2022-12-30 thomas
208 581fa623 2022-12-30 thomas echo "gotsh: unexpected want-line received" > $testroot/stderr.expected
209 581fa623 2022-12-30 thomas
210 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stdout.expected $testroot/stdout 0 108
211 581fa623 2022-12-30 thomas ret=$?
212 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
213 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
214 581fa623 2022-12-30 thomas test_done "$testroot" "1"
215 581fa623 2022-12-30 thomas return 1
216 581fa623 2022-12-30 thomas fi
217 581fa623 2022-12-30 thomas
218 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
219 581fa623 2022-12-30 thomas ret=$?
220 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
221 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
222 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
223 581fa623 2022-12-30 thomas test_done "$testroot" "1"
224 581fa623 2022-12-30 thomas return 1
225 581fa623 2022-12-30 thomas fi
226 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
227 581fa623 2022-12-30 thomas }
228 581fa623 2022-12-30 thomas
229 581fa623 2022-12-30 thomas # Unknown repository
230 581fa623 2022-12-30 thomas test_request_bad_repository() {
231 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_repository`
232 581fa623 2022-12-30 thomas
233 45b9d1e9 2022-12-30 thomas echo "0054want $dummy_commit aaaaaaaaa bbbbbbbbbbbbb ccccccccc" \
234 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack '/XXXX-XXXX' \
235 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
236 581fa623 2022-12-30 thomas
237 581fa623 2022-12-30 thomas echo -n "001fERR no git repository found" > $testroot/stdout.expected
238 581fa623 2022-12-30 thomas
239 581fa623 2022-12-30 thomas echo "gotsh: no git repository found" > $testroot/stderr.expected
240 581fa623 2022-12-30 thomas
241 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stdout.expected $testroot/stdout
242 581fa623 2022-12-30 thomas ret=$?
243 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
244 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
245 581fa623 2022-12-30 thomas test_done "$testroot" "1"
246 581fa623 2022-12-30 thomas return 1
247 581fa623 2022-12-30 thomas fi
248 581fa623 2022-12-30 thomas
249 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
250 581fa623 2022-12-30 thomas ret=$?
251 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
252 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
253 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
254 581fa623 2022-12-30 thomas test_done "$testroot" "1"
255 581fa623 2022-12-30 thomas return 1
256 581fa623 2022-12-30 thomas fi
257 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
258 581fa623 2022-12-30 thomas
259 581fa623 2022-12-30 thomas }
260 581fa623 2022-12-30 thomas
261 581fa623 2022-12-30 thomas # Repository with name of 255 symbols
262 581fa623 2022-12-30 thomas test_request_bad_large_repo_name() {
263 581fa623 2022-12-30 thomas local testroot=`test_init test_request_bad_large_repo_name`
264 581fa623 2022-12-30 thomas
265 45b9d1e9 2022-12-30 thomas # build a string of 255 "A": 63 "A" four times plus tree more "A"
266 45b9d1e9 2022-12-30 thomas local a=AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
267 45b9d1e9 2022-12-30 thomas local repo_name="AAA$a$a$a$a"
268 581fa623 2022-12-30 thomas
269 45b9d1e9 2022-12-30 thomas echo "0054want $dummy_commit aaaaaaaaa bbbbbbbbbbbbb ccccccccc" \
270 45b9d1e9 2022-12-30 thomas | ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack "/$repo_name" \
271 45b9d1e9 2022-12-30 thomas > $testroot/stdout 2>$testroot/stderr
272 45b9d1e9 2022-12-30 thomas
273 581fa623 2022-12-30 thomas echo -n "0018ERR buffer too small" > $testroot/stdout.expected
274 581fa623 2022-12-30 thomas
275 581fa623 2022-12-30 thomas echo "gotsh: buffer too small" > $testroot/stderr.expected
276 581fa623 2022-12-30 thomas
277 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stdout.expected $testroot/stdout
278 581fa623 2022-12-30 thomas ret=$?
279 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
280 581fa623 2022-12-30 thomas echo "unexpected stdout" >&2
281 581fa623 2022-12-30 thomas test_done "$testroot" "1"
282 581fa623 2022-12-30 thomas return 1
283 581fa623 2022-12-30 thomas fi
284 581fa623 2022-12-30 thomas
285 45b9d1e9 2022-12-30 thomas cmp -s $testroot/stderr.expected $testroot/stderr
286 581fa623 2022-12-30 thomas ret=$?
287 581fa623 2022-12-30 thomas if [ $ret -ne 0 ]; then
288 581fa623 2022-12-30 thomas echo "unexpected stderr" >&2
289 45b9d1e9 2022-12-30 thomas diff -u $testroot/stderr.expected $testroot/stderr
290 581fa623 2022-12-30 thomas test_done "$testroot" "1"
291 581fa623 2022-12-30 thomas return 1
292 581fa623 2022-12-30 thomas fi
293 581fa623 2022-12-30 thomas test_done "$testroot" "$ret"
294 581fa623 2022-12-30 thomas }
295 a72fb394 2023-01-23 thomas
296 a72fb394 2023-01-23 thomas test_request_bad_no_repo() {
297 a72fb394 2023-01-23 thomas local testroot=`test_init test_request_bad_no_repo`
298 45b9d1e9 2022-12-30 thomas
299 a72fb394 2023-01-23 thomas for i in `seq 10`; do
300 a72fb394 2023-01-23 thomas ssh ${GOTD_DEVUSER}@127.0.0.1 git-upload-pack \
301 a72fb394 2023-01-23 thomas >/dev/null 2>/dev/null </dev/null
302 a72fb394 2023-01-23 thomas done
303 a72fb394 2023-01-23 thomas
304 a72fb394 2023-01-23 thomas # should still be able to clone; the repo is empty however
305 a72fb394 2023-01-23 thomas got clone -q ${GOTD_TEST_REPO_URL} $testroot/repo-clone \
306 a72fb394 2023-01-23 thomas 2> $testroot/stderr
307 a72fb394 2023-01-23 thomas cat <<EOF > $testroot/stderr.expected
308 a72fb394 2023-01-23 thomas got-fetch-pack: could not find any branches to fetch
309 a72fb394 2023-01-23 thomas got: could not find any branches to fetch
310 a72fb394 2023-01-23 thomas EOF
311 a72fb394 2023-01-23 thomas
312 a72fb394 2023-01-23 thomas if ! cmp -s "$testroot/stderr.expected" "$testroot/stderr"; then
313 a72fb394 2023-01-23 thomas echo "got clone failed for unexpected reason" >&2
314 a72fb394 2023-01-23 thomas diff -u "$testroot/stderr.expected" "$testroot/stderr"
315 a72fb394 2023-01-23 thomas test_done "$testroot" 1
316 a72fb394 2023-01-23 thomas return
317 a72fb394 2023-01-23 thomas fi
318 a72fb394 2023-01-23 thomas
319 a72fb394 2023-01-23 thomas test_done "$testroot" 0
320 a72fb394 2023-01-23 thomas }
321 a72fb394 2023-01-23 thomas
322 581fa623 2022-12-30 thomas test_parseargs "$@"
323 581fa623 2022-12-30 thomas run_test test_request_bad_commit
324 581fa623 2022-12-30 thomas run_test test_request_bad_length_zero
325 581fa623 2022-12-30 thomas run_test test_request_bad_length_empty
326 581fa623 2022-12-30 thomas run_test test_request_bad_length_small
327 581fa623 2022-12-30 thomas run_test test_request_bad_length_large
328 581fa623 2022-12-30 thomas run_test test_request_bad_capabilities
329 581fa623 2022-12-30 thomas run_test test_request_bad_repository
330 581fa623 2022-12-30 thomas run_test test_request_bad_large_repo_name
331 a72fb394 2023-01-23 thomas run_test test_request_bad_no_repo